// exampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "example.h"
#include "exampleDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CExampleDlg dialog

CExampleDlg::CExampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CExampleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CExampleDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CExampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CExampleDlg)
	DDX_Control(pDX, IDC_PROGRESS, m_progress);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CExampleDlg, CDialog)
	//{{AFX_MSG_MAP(CExampleDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_DEMO, OnDemo)
	ON_BN_CLICKED(IDC_DEMO2, OnDemo2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CExampleDlg message handlers

BOOL CExampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CExampleDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CExampleDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}
/////////////////////////////////////////////////////////////////////////////
BOOL CExampleDlg::LoadPdfToImageDll()
{
	m_hinstLib = LoadLibrary("pdftoimage.dll");
	if( m_hinstLib == NULL ){ 
		return FALSE;
	}

	pLoad = (MLoad *)GetProcAddress(m_hinstLib, "MLoad");
	if( pLoad == NULL ){ 
		FreePdfToImageDll(); 
		return FALSE;
	}
	pEncode = (MEncode *)GetProcAddress(m_hinstLib, "MEncode");
	if( pEncode == NULL ){ 
		FreePdfToImageDll(); 
		return FALSE;
	}
	pFree = (MFree *)GetProcAddress(m_hinstLib, "MFree");
	if( pFree == NULL ){ 
		FreePdfToImageDll(); 
		return FALSE;
	}
	pGetCount = (MGetCount *)GetProcAddress(m_hinstLib, "MGetCount");
	if( pGetCount == NULL ){ 
		FreePdfToImageDll(); 
		return FALSE;
	}
	pSetParam = (MSetParam *)GetProcAddress(m_hinstLib, "MSetParam");
	if( pSetParam == NULL ){ 
		FreePdfToImageDll(); 
		return FALSE;
	}

	return TRUE;
}
/////////////////////////////////////////////////////////////////////////////
BOOL CExampleDlg::FreePdfToImageDll()
{
	if( m_hinstLib ){
        FreeLibrary(m_hinstLib);
	}
	return TRUE;
}
/////////////////////////////////////////////////////////////////////////////
void CExampleDlg::OnDemo() 
{
	if( LoadPdfToImageDll() == FALSE ){
		MessageBox("Load pdftoimage.dll failed!");
		return;
	}

	long id = pLoad("test.pdf",NULL);
	if(id==-1){
		MessageBox("PDF file unexist or damaged!");
		FreePdfToImageDll();
		return;
	}
	if(id==-2){
		MessageBox("PDF file is restricted!");
		FreePdfToImageDll();
		return;
	}

	//The 1 is generate a multi-page TIFF file, the 0 is generate a TIFF file for each page
	long multipages = 1;
	pSetParam(id,"",IMAGE_FORMAT_TIF,24,COMPRESSION_LZW,0,0,multipages,0,0,0,96,96);

	long pageCount = pGetCount(id);
	for(long i=1; i<=pageCount; i++){
		pEncode(id,i);
		m_progress.SetPos( i*100/pageCount );
	}
	pFree(id);

	FreePdfToImageDll();
	MessageBox("Convert finished!");
}
/////////////////////////////////////////////////////////////////////////////
void CExampleDlg::OnDemo2() 
{
	if( LoadPdfToImageDll() == FALSE ){
		MessageBox("Load pdftoimage.dll failed!");
		return;
	}

	long id = pLoad("test.pdf",NULL);	
	if(id==-1){
		MessageBox("PDF file unexist or damaged!");
		FreePdfToImageDll();
		return;
	}
	if(id==-2){
		MessageBox("PDF file is restricted!");
		FreePdfToImageDll();
		return;
	}

	pSetParam(id,"",IMAGE_FORMAT_JPG,24,0,75,0,0,90,800,600,120,120);

	long pageCount = pGetCount(id);
	for(long i=1; i<=pageCount; i++){
		pEncode(id,i);
		m_progress.SetPos( i*100/pageCount );
	}
	pFree(id);

	FreePdfToImageDll();
	MessageBox("Convert finished!");
}
